> ## Documentation Index
> Fetch the complete documentation index at: https://docs.leen.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# List Vulnerabilities

> List all the vulnerabilities for a given connection.



## OpenAPI

````yaml get /vms/vulnerabilities
openapi: 3.1.0
info:
  title: Leen Security API
  version: 0.0.1
servers:
  - url: https://api.leen.dev/v1
    description: Production API
  - url: https://api.eu-c1.leen.dev/v1
    description: Production API (EU Region)
  - url: https://api.ap-se2.leen.dev/v1
    description: Production Api (APAC Region)
security: []
paths:
  /vms/vulnerabilities:
    get:
      tags:
        - vms
      summary: List Vulnerabilities
      description: List all the vulnerabilities for a given connection.
      operationId: get_vulnerabilities
      parameters:
        - name: sort
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                pattern: >-
                  ^severity$|^severity\:asc$|^severity\:desc$|^updated_at$|^updated_at\:asc$|^updated_at\:desc$|^state_updated_at$|^state_updated_at\:asc$|^state_updated_at\:desc$
              - type: 'null'
            description: Sort by field
            title: Sort
          description: Sort by field
        - name: stateUpdatedSince
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: date-time
              - type: 'null'
            description: >-
              Datetime filter, only return vulnerabilities where the state was
              updated since this datetime. Example format:
              `2021-01-01T00:00:00+00:00`
            title: Stateupdatedsince
          description: >-
            Datetime filter, only return vulnerabilities where the state was
            updated since this datetime. Example format:
            `2021-01-01T00:00:00+00:00`
          example: '2021-01-01T00:00:00+00:00'
        - name: firstSeenSince
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: date-time
              - type: 'null'
            description: >-
              Datetime filter, only return vulnerabilities where the first seen
              since this datetime. Example format: `2021-01-01T00:00:00+00:00`
            title: Firstseensince
          description: >-
            Datetime filter, only return vulnerabilities where the first seen
            since this datetime. Example format: `2021-01-01T00:00:00+00:00`
          example: '2021-01-01T00:00:00+00:00'
        - name: lastSeenSince
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: date-time
              - type: 'null'
            description: >-
              Datetime filter, only return vulnerabilities where the last seen
              since this datetime. Example format: `2021-01-01T00:00:00+00:00`
            title: Lastseensince
          description: >-
            Datetime filter, only return vulnerabilities where the last seen
            since this datetime. Example format: `2021-01-01T00:00:00+00:00`
          example: '2021-01-01T00:00:00+00:00'
        - name: deviceId
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Device ID Filter, comma separated
            title: Deviceid
          description: Device ID Filter, comma separated
          example: >-
            123e4567-e89b-12d3-a456-426614174000,
            123e4567-e89b-12d3-a456-426614174001
        - name: resourceId
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Resource ID Filter, comma separated
            title: Resourceid
          description: Resource ID Filter, comma separated
          example: >-
            123e4567-e89b-12d3-a456-426614174000,
            123e4567-e89b-12d3-a456-426614174001
        - name: severity
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Vulnerability severity filter, comma separated
            title: Severity
          description: Vulnerability severity filter, comma separated
          example: critical,high
        - name: state
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Vulnerability state filter, comma separated
            title: State
          description: Vulnerability state filter, comma separated
          example: open,closed
        - name: port
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Port number filter, comma separated
            title: Port
          description: Port number filter, comma separated
          example: 80,443
        - name: protocol
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Protocol filter, comma separated
            title: Protocol
          description: Protocol filter, comma separated
          example: tcp,udp
        - name: category
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Vulnerability category filter, comma separated
            title: Category
          description: Vulnerability category filter, comma separated
          example: web,network
        - name: cve
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: CVE ID filter, comma separated
            title: Cve
          description: CVE ID filter, comma separated
          example: CVE-2021-1234,CVE-2021-5678
        - name: includeDeviceGroups
          in: query
          required: false
          schema:
            type: boolean
            description: Include device groups in the devices attached to the vulnerability
            default: false
            title: Includedevicegroups
          description: Include device groups in the devices attached to the vulnerability
        - name: deviceGroupId
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Device group ID filter, comma separated
            title: Devicegroupid
          description: Device group ID filter, comma separated
          example: >-
            123e4567-e89b-12d3-a456-426614174002,
            123e4567-e89b-12d3-a456-426614174003
        - name: ids
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: >-
              Vulnerability ID filter, comma separated. Need to be valid UUIDs.
              Max 100 IDs
            title: Ids
          description: >-
            Vulnerability ID filter, comma separated. Need to be valid UUIDs.
            Max 100 IDs
          example: >-
            123e4567-e89b-12d3-a456-426614174004,123e4567-e89b-12d3-a456-426614174005
        - name: enableCursor
          in: query
          required: false
          schema:
            type: boolean
            description: >-
              Enable cursor based pagination instead of default offset-based
              pagination
            default: false
            title: Enablecursor
          description: >-
            Enable cursor based pagination instead of default offset-based
            pagination
        - name: updatedSince
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: date-time
              - type: 'null'
            description: >-
              Datetime filter, only return items updated since this datetime.
              Example format: `2021-01-01T00:00:00+00:00`
            title: Updatedsince
          description: >-
            Datetime filter, only return items updated since this datetime.
            Example format: `2021-01-01T00:00:00+00:00`
          example: '2021-01-01T00:00:00+00:00'
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            minimum: 0
            description: Limit size (page size)
            default: 100
            title: Limit
          description: Limit size (page size)
        - name: offset
          in: query
          required: false
          schema:
            type: integer
            minimum: 0
            description: Offset index (starting index of page)
            default: 0
            title: Offset
          description: Offset index (starting index of page)
        - name: excludeTotal
          in: query
          required: false
          schema:
            type: boolean
            description: Skips returning the total rows, total is set to null when true
            default: false
            title: Excludetotal
          description: Skips returning the total rows, total is set to null when true
        - name: cursor
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Skip token to continue from the last item in the previous page
            title: Cursor
          description: Skip token to continue from the last item in the previous page
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: >-
                      #/components/schemas/OffsetPaginatedResponse_VulnerabilityRespModel_
                  - $ref: >-
                      #/components/schemas/KeySetPaginatedResponse_VulnerabilityRespModel_
                title: Response Get Vulnerabilities
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Unprocessable Entity
      security:
        - Connection-ID: []
          API-Key: []
components:
  schemas:
    OffsetPaginatedResponse_VulnerabilityRespModel_:
      properties:
        count:
          type: integer
          title: Count
          description: Number of items return in the response
        total:
          anyOf:
            - type: integer
            - type: 'null'
          title: Total
          description: Total number of items that can be returned
        items:
          items:
            $ref: '#/components/schemas/VulnerabilityRespModel'
          type: array
          title: Items
          description: List of items returned in the response
      type: object
      required:
        - count
        - items
      title: OffsetPaginatedResponse[VulnerabilityRespModel]
    KeySetPaginatedResponse_VulnerabilityRespModel_:
      properties:
        items:
          items:
            $ref: '#/components/schemas/VulnerabilityRespModel'
          type: array
          title: Items
          description: List of items returned in the response
        next_cursor:
          anyOf:
            - type: string
            - type: 'null'
          title: Next Cursor
          description: Skip token to continue from the last item in the previous page
        previous_cursor:
          anyOf:
            - type: string
            - type: 'null'
          title: Previous Cursor
          description: Skip token to continue from the first item in the previous page
      type: object
      required:
        - items
      title: KeySetPaginatedResponse[VulnerabilityRespModel]
    ErrorResponse:
      properties:
        type:
          type: string
          title: Type
          description: Type of error
        code:
          type: string
          title: Code
          description: Error code
        message:
          type: string
          title: Message
          description: Error message
        detail:
          items:
            type: object
          type: array
          title: Detail
          description: List of error dictionaries
      type: object
      required:
        - type
        - code
        - message
        - detail
      title: ErrorResponse
    VulnerabilityRespModel:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          description: Leen's UUID for the vulnerability
        device:
          anyOf:
            - $ref: '#/components/schemas/DeviceRespModel'
            - $ref: '#/components/schemas/DeviceWithGroupsRespModel'
            - type: 'null'
          title: Device
          description: >-
            Device attached to the vulnerability, include device groups with
            includeDeviceGroups query parameter
        resource:
          anyOf:
            - $ref: '#/components/schemas/ResourceRespModel'
            - type: 'null'
          description: Resource attached to the vulnerability
        name:
          type: string
          title: Name
          description: Name of vulnerability, provided by the upstream vendor
        description:
          type: string
          title: Description
          description: Description of vulnerability, provided by the upstream vendor
        scan_output:
          anyOf:
            - type: string
            - type: 'null'
          title: Scan Output
          description: Scan output that was provided when detected on the device
        cve:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Cve
          description: List of CVEs associated with the vulnerability
        cvss_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Cvss Version
          description: CVSS version
        cvss_base_score:
          anyOf:
            - type: number
            - type: 'null'
          title: Cvss Base Score
          default: CVSS base score
        cvss_vector:
          anyOf:
            - type: string
            - type: 'null'
          title: Cvss Vector
          description: >-
            CVSS vector uses cvss3 when available, provided by the upstream
            vendor
        cvss_temporal_score:
          anyOf:
            - type: number
            - type: 'null'
          title: Cvss Temporal Score
          description: CVSS temporal score
        cvss_temporal_vector:
          anyOf:
            - type: string
            - type: 'null'
          title: Cvss Temporal Vector
          description: CVSS temporal vector
        cert_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Cert Id
          description: >-
            Corresponds to an identifier in the vulnerability database provided
            by the US Computer Emergency Readiness Team (US-CERT)
        port:
          anyOf:
            - type: integer
            - type: 'null'
          title: Port
          description: Port number of the vulnerability that was detected
        protocol:
          anyOf:
            - type: string
            - type: 'null'
          title: Protocol
          description: 'Protocol of the vulnerability that was detected, example: tcp'
        service:
          anyOf:
            - type: string
            - type: 'null'
          title: Service
          description: 'Service of the vulnerability that was detected, example: http'
        severity:
          allOf:
            - $ref: '#/components/schemas/VulnerabilitySeverity'
          default: none
        first_seen:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: First Seen
          description: First detection date
        last_seen:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Last Seen
          description: Last detection date
        state:
          allOf:
            - $ref: '#/components/schemas/VulnerabilityState'
          default: open
        updated_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Updated At
          description: The last time the vulnerability was updated
        state_updated_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: State Updated At
          description: The last time the state was updated
        patchable:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Patchable
          description: A patch is available
        solution:
          anyOf:
            - type: string
            - type: 'null'
          title: Solution
          description: Solution for the vulnerability, provided by upstream vendor
        category:
          anyOf:
            - $ref: '#/components/schemas/VulnerabilityCategory'
            - type: 'null'
          description: Vulnerability category
        vulnerability_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Vulnerability Url
          description: URL to the vulnerability details, provided by the upstream vendor
        vendor:
          allOf:
            - $ref: '#/components/schemas/VulnerabilityVendor'
          description: Source vendor
        vendor_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Vendor Id
          description: Vendor's ID of the vulnerability
        vendor_severity:
          anyOf:
            - type: string
            - type: 'null'
          title: Vendor Severity
          description: Passthrough value of severity
        vendor_scan_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Vendor Scan Id
          description: 'Vendor''s ID of the scan that detected the '
        vendor_data:
          anyOf:
            - type: object
            - type: 'null'
          title: Vendor Data
          description: Vendor specific pass through data, values can vary based on vendor
      type: object
      required:
        - id
        - name
        - description
        - scan_output
        - cve
        - cvss_version
        - cvss_vector
        - cvss_temporal_score
        - cvss_temporal_vector
        - cert_id
        - port
        - protocol
        - service
        - first_seen
        - last_seen
        - updated_at
        - state_updated_at
        - patchable
        - solution
        - category
        - vendor
        - vendor_id
        - vendor_severity
        - vendor_scan_id
      title: Vulnerability
    DeviceRespModel:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        status:
          $ref: '#/components/schemas/DeviceStatus'
        platform:
          anyOf:
            - $ref: '#/components/schemas/DevicePlatform'
            - type: 'null'
        hostnames:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Hostnames
        os_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Os Version
        os_major_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Os Major Version
        os_minor_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Os Minor Version
        fqdns:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Fqdns
        ipv4s:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Ipv4S
        ipv6s:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Ipv6S
        mac_addresses:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Mac Addresses
        last_seen:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Last Seen
        first_seen:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: First Seen
        source_vendors:
          items:
            $ref: '#/components/schemas/DeviceVendor'
          type: array
          title: Source Vendors
        installed_software:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Installed Software
        ad_info:
          anyOf:
            - $ref: '#/components/schemas/DeviceADInfo'
            - type: 'null'
        cloud_metadata:
          anyOf:
            - $ref: '#/components/schemas/AWSMetadata'
            - type: 'null'
          description: CloudMetadata, currently only AWS is supported
        tags:
          anyOf:
            - items:
                $ref: '#/components/schemas/DeviceTags'
              type: array
            - type: 'null'
          title: Tags
        identities:
          anyOf:
            - items:
                $ref: '#/components/schemas/DeviceIdentity'
              type: array
            - type: 'null'
          title: Identities
        vendor_data:
          anyOf:
            - type: object
            - type: 'null'
          title: Vendor Data
          description: Vendor specific pass through data, values can vary based on vendor
      type: object
      required:
        - id
        - status
        - last_seen
        - first_seen
        - source_vendors
        - installed_software
        - ad_info
      title: Device
    DeviceWithGroupsRespModel:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        status:
          $ref: '#/components/schemas/DeviceStatus'
        platform:
          anyOf:
            - $ref: '#/components/schemas/DevicePlatform'
            - type: 'null'
        hostnames:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Hostnames
        os_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Os Version
        os_major_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Os Major Version
        os_minor_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Os Minor Version
        fqdns:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Fqdns
        ipv4s:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Ipv4S
        ipv6s:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Ipv6S
        mac_addresses:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Mac Addresses
        last_seen:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Last Seen
        first_seen:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: First Seen
        source_vendors:
          items:
            $ref: '#/components/schemas/DeviceVendor'
          type: array
          title: Source Vendors
        installed_software:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Installed Software
        ad_info:
          anyOf:
            - $ref: '#/components/schemas/DeviceADInfo'
            - type: 'null'
        cloud_metadata:
          anyOf:
            - $ref: '#/components/schemas/AWSMetadata'
            - type: 'null'
          description: CloudMetadata, currently only AWS is supported
        tags:
          anyOf:
            - items:
                $ref: '#/components/schemas/DeviceTags'
              type: array
            - type: 'null'
          title: Tags
        identities:
          anyOf:
            - items:
                $ref: '#/components/schemas/DeviceIdentity'
              type: array
            - type: 'null'
          title: Identities
        vendor_data:
          anyOf:
            - type: object
            - type: 'null'
          title: Vendor Data
          description: Vendor specific pass through data, values can vary based on vendor
        device_groups:
          items:
            $ref: '#/components/schemas/DeviceGroupsBase'
          type: array
          title: Device Groups
          description: >-
            Pass in the includeDeviceGroups query parameter to include device
            group information.
          default: []
      type: object
      required:
        - id
        - status
        - last_seen
        - first_seen
        - source_vendors
        - installed_software
        - ad_info
      title: DeviceWithGroups
    ResourceRespModel:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          description: Leen's UUID for the resource
        name:
          type: string
          title: Name
          description: Resource name
        tags:
          anyOf:
            - items:
                $ref: '#/components/schemas/ResourceTag'
              type: array
            - type: 'null'
          title: Tags
          description: List of arbitrary tags/metadata for the resource
        type:
          allOf:
            - $ref: '#/components/schemas/ResourceTypeEnum'
          description: Type of the resource
        state:
          allOf:
            - $ref: '#/components/schemas/ResourceStateEnum'
          description: State of the resource
        groups:
          anyOf:
            - items:
                $ref: '#/components/schemas/ResourceGroup'
              type: array
            - type: 'null'
          title: Groups
          description: Groups associated with the resource
        data:
          anyOf:
            - $ref: '#/components/schemas/ResourceContainer'
            - $ref: '#/components/schemas/ResourceHost'
            - $ref: '#/components/schemas/ResourceImage'
            - $ref: '#/components/schemas/ResourceBranch'
            - type: 'null'
          title: Data
          description: Additional data or properties about the resource
        cloud_metadata:
          anyOf:
            - $ref: '#/components/schemas/ResourceCloudMetadata'
            - type: 'null'
          description: Cloud metadata for the resource
        url:
          anyOf:
            - type: string
            - type: 'null'
          title: Url
          description: URL associated with the resource
        vendor:
          type: string
          title: Vendor
          description: The source vendor of the resource
        first_seen:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: First Seen
          description: Timestamp when the resource was first seen
        last_seen:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Last Seen
          description: Timestamp when the resource was last seen
        vendor_attributes:
          allOf:
            - $ref: '#/components/schemas/ResourceVendorAttributes'
          description: Vendor-specific attributes like IDs
      type: object
      required:
        - id
        - name
        - type
        - state
        - vendor
        - vendor_attributes
      title: Resource
      description: Response model for returning resource details via an API endpoint.
    VulnerabilitySeverity:
      type: string
      enum:
        - critical
        - high
        - medium
        - low
        - info
        - none
      title: VulnerabilitySeverity
    VulnerabilityState:
      type: string
      enum:
        - open
        - closed
        - reopened
        - ignored
        - deleted
      title: VulnerabilityState
    VulnerabilityCategory:
      type: string
      enum:
        - web
        - network
        - database
        - application
        - os
        - other
        - general
        - attack_vector
      title: VulnerabilityCategory
    VulnerabilityVendor:
      type: string
      enum:
        - tenable
        - qualys
        - snyk
        - insightvm
        - crowdstrike_spotlight
        - sentinelone_vms
        - MS_DEFENDER_VMS
        - WIZ_VMS
        - AWS_INSPECTOR2
      title: VulnerabilityVendor
    DeviceStatus:
      type: string
      enum:
        - active
        - offline
        - quarantined
        - unknown
        - deleted
      title: DeviceStatus
    DevicePlatform:
      type: string
      enum:
        - mac
        - windows
        - linux
        - unknown
      title: DevicePlatform
    DeviceVendor:
      properties:
        vendor:
          type: string
          title: Vendor
        vendor_id:
          type: string
          title: Vendor Id
        agent_info:
          anyOf:
            - $ref: '#/components/schemas/DeviceAgentInfo'
            - type: 'null'
      type: object
      required:
        - vendor
        - vendor_id
      title: DeviceVendor
    DeviceADInfo:
      properties:
        org_unit:
          anyOf:
            - type: string
            - type: 'null'
          title: Org Unit
        site_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Site Name
        domain:
          anyOf:
            - type: string
            - type: 'null'
          title: Domain
        device_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Device Id
      type: object
      title: DeviceADInfo
    AWSMetadata:
      properties:
        cloud_provider:
          allOf:
            - $ref: '#/components/schemas/CloudProvider'
          default: aws
        account_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Account Id
        region:
          anyOf:
            - type: string
            - type: 'null'
          title: Region
        availability_zone:
          anyOf:
            - type: string
            - type: 'null'
          title: Availability Zone
        instance_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Instance Id
        instance_type:
          anyOf:
            - type: string
            - type: 'null'
          title: Instance Type
        image_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Image Id
        kernel_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Kernel Id
        vpc_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Vpc Id
        subnet_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Subnet Id
      type: object
      title: AWSMetadata
    DeviceTags:
      properties:
        key:
          type: string
          title: Key
        value:
          type: string
          title: Value
        source:
          $ref: '#/components/schemas/DeviceTagSource'
      type: object
      required:
        - key
        - value
        - source
      title: DeviceTags
    DeviceIdentity:
      properties:
        username:
          type: string
          title: Username
        user_sid:
          anyOf:
            - type: string
            - type: 'null'
          title: User Sid
      type: object
      required:
        - username
      title: DeviceIdentity
    DeviceGroupsBase:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        created_by:
          anyOf:
            - type: string
            - type: 'null'
          title: Created By
        vendor_id:
          type: string
          title: Vendor Id
        vendor_created_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Vendor Created At
        vendor_data:
          anyOf:
            - type: object
            - type: 'null'
          title: Vendor Data
          description: Vendor specific pass through data, values can vary based on vendor
        vendor:
          type: string
          title: Vendor
      type: object
      required:
        - id
        - name
        - vendor_id
        - vendor
      title: DeviceGroupsBase
    ResourceTag:
      properties:
        key:
          type: string
          title: Key
        value:
          type: string
          title: Value
        source:
          type: string
          enum:
            - wiz_vms
            - gitlab
            - checkmarx
            - mend
            - qualys
            - aws
            - insight_vm
            - orca
            - blackkite
          title: Source
      type: object
      required:
        - key
        - value
        - source
      title: ResourceTag
    ResourceTypeEnum:
      type: string
      enum:
        - BRANCH
        - HOST
        - CONTAINER
        - DEPENDENCY
        - IMAGE
        - REPOSITORY
        - VENDOR
        - KUBERNETES
        - UNKNOWN
      title: ResourceTypeEnum
      description: Enumeration for resource types.
    ResourceStateEnum:
      type: string
      enum:
        - ACTIVE
        - IGNORED
        - DELETED
        - INACTIVE
        - QUARANTINED
        - UNKNOWN
      title: ResourceStateEnum
    ResourceGroup:
      properties:
        name:
          type: string
          title: Name
          description: The name of the group.
        uid:
          type: string
          title: Uid
          description: The unique identifier of the group.
      type: object
      required:
        - name
        - uid
      title: ResourceGroup
      description: ORM model representing a groups in a resource.
    ResourceContainer:
      properties:
        hostnames:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Hostnames
          description: List of hostnames for the container
        image:
          anyOf:
            - type: string
            - type: 'null'
          title: Image
          description: Container image identifier
      type: object
      title: ResourceContainer
      description: ORM model representing a container in a resource.
    ResourceHost:
      properties:
        image:
          anyOf:
            - type: string
            - type: 'null'
          title: Image
          description: Host image identifier
        fqdns:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Fqdns
          description: Fully qualified domain names of the host
        hostnames:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Hostnames
          description: List of hostnames for the host
        installed_software:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Installed Software
          description: Installed software on the host
        ipv4s:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Ipv4S
          description: IPv4 addresses associated with the host
        ipv6s:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Ipv6S
          description: IPv6 addresses associated with the host
        mac_addresses:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Mac Addresses
          description: MAC addresses associated with the host
        os_major_version:
          anyOf:
            - type: integer
            - type: 'null'
          title: Os Major Version
          description: Major version of the host's operating system
        os_minor_version:
          anyOf:
            - type: integer
            - type: 'null'
          title: Os Minor Version
          description: Minor version of the host's operating system
        os_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Os Version
          description: Full operating system version of the host
        platform:
          anyOf:
            - $ref: '#/components/schemas/ResourcePlatformEnum'
            - type: 'null'
          description: Platform on which the host is running
        agents:
          anyOf:
            - items:
                $ref: '#/components/schemas/ResourceHostAgent'
              type: array
            - type: 'null'
          title: Agents
          description: Agent information for the host
        ad_org_unit:
          anyOf:
            - type: string
            - type: 'null'
          title: Ad Org Unit
          description: Active Directory organizational unit
        ad_site_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Ad Site Name
          description: Active Directory site name
        ad_domain:
          anyOf:
            - type: string
            - type: 'null'
          title: Ad Domain
          description: Active Directory domain
        ad_device_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Ad Device Id
          description: Active Directory device ID
        is_deleted:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Is Deleted
          description: Whether the host is deleted
        deleted_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Deleted At
          description: When the host was deleted
      type: object
      title: ResourceHost
      description: ORM model representing a host in a resource.
    ResourceImage:
      properties:
        labels:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Labels
          description: Image labels
        hash:
          anyOf:
            - $ref: '#/components/schemas/ResourceHash'
            - type: 'null'
          description: Image hash
      type: object
      title: ResourceImage
      description: ORM model representing an image in a resource.
    ResourceBranch:
      properties:
        code_repo:
          anyOf:
            - type: string
            - type: 'null'
          title: Code Repo
          description: Code repository name
        repo_branch_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Repo Branch Name
          description: Repository branch name
      type: object
      title: ResourceBranch
      description: ORM model representing a branch in a resource.
    ResourceCloudMetadata:
      properties:
        account_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Account Id
          description: Cloud account identifier
        account_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Account Name
          description: Cloud account name
        cloud_provider:
          anyOf:
            - type: string
            - type: 'null'
          title: Cloud Provider
          description: Cloud service provider
        image_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Image Id
          description: Cloud image identifier
        instance_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Instance Id
          description: Cloud instance identifier
        instance_type:
          anyOf:
            - type: string
            - type: 'null'
          title: Instance Type
          description: Type of cloud instance
        region:
          anyOf:
            - type: string
            - type: 'null'
          title: Region
          description: Cloud region
        subnet_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Subnet Id
          description: Cloud subnet identifier
        vpc_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Vpc Id
          description: Cloud VPC identifier
      type: object
      title: ResourceCloudMetadata
      description: ORM model representing cloud metadata in a resource.
    ResourceVendorAttributes:
      properties:
        id:
          type: string
          title: Id
          description: Vendor specific ID
        data:
          anyOf:
            - $ref: '#/components/schemas/QualysDeviceVendorData'
            - $ref: '#/components/schemas/TenableDeviceVendorData'
            - $ref: '#/components/schemas/OrcaResourceVendorAttributesData'
            - $ref: '#/components/schemas/UpwindResourceVendorAttributesData'
            - type: 'null'
          title: Data
          description: Vendor specific data
      type: object
      required:
        - id
      title: ResourceVendorAttributes
    DeviceAgentInfo:
      properties:
        agent_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Agent Version
        signature_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Signature Version
        policies:
          anyOf:
            - items:
                type: object
              type: array
            - type: 'null'
          title: Policies
      type: object
      title: DeviceAgentInfo
    CloudProvider:
      type: string
      enum:
        - aws
      const: aws
      title: CloudProvider
    DeviceTagSource:
      type: string
      enum:
        - aws
        - qualys
        - wiz_vms
      title: DeviceTagSource
    ResourcePlatformEnum:
      type: string
      enum:
        - WINDOWS
        - LINUX
        - MAC
        - UNKNOWN
      title: ResourcePlatformEnum
      description: Enumeration for resource platforms.
    ResourceHostAgent:
      properties:
        vendor:
          type: string
          title: Vendor
          description: Vendor of the agent
        product:
          type: string
          title: Product
          description: Product name of the agent
        version:
          anyOf:
            - type: string
            - type: 'null'
          title: Version
          description: Version of the agent
        signature_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Signature Version
          description: Signature version of the agent, usually related to EDR agents
        vendor_attributes:
          anyOf:
            - $ref: '#/components/schemas/ResourceHostAgentVendorAttributes'
            - type: 'null'
          description: Vendor-specific attributes of the agent
      type: object
      required:
        - vendor
        - product
      title: ResourceHostAgent
      description: ORM model representing agent information in a resource.
    ResourceHash:
      properties:
        algorithm:
          anyOf:
            - type: string
            - type: 'null'
          title: Algorithm
        value:
          anyOf:
            - type: string
            - type: 'null'
          title: Value
      type: object
      title: ResourceHash
    QualysDeviceVendorData:
      properties:
        vendor:
          type: string
          enum:
            - qualys
          const: qualys
          title: Vendor
        asset_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Asset Id
        host_id:
          type: string
          title: Host Id
        tracking_method:
          anyOf:
            - type: string
            - type: 'null'
          title: Tracking Method
      type: object
      required:
        - vendor
        - host_id
      title: QualysDeviceVendorData
    TenableDeviceVendorData:
      properties:
        vendor:
          type: string
          enum:
            - tenable
          const: tenable
          title: Vendor
          default: tenable
        is_licensed:
          type: boolean
          title: Is Licensed
        first_seen:
          anyOf:
            - type: string
            - type: 'null'
          title: First Seen
        last_seen:
          anyOf:
            - type: string
            - type: 'null'
          title: Last Seen
      type: object
      required:
        - is_licensed
      title: TenableDeviceVendorData
    OrcaResourceVendorAttributesData:
      properties:
        vendor:
          type: string
          enum:
            - ORCA
          const: ORCA
          title: Vendor
          default: ORCA
        category:
          type: string
          title: Category
        subcategory:
          type: string
          title: Subcategory
        type:
          type: string
          title: Type
      type: object
      required:
        - category
        - subcategory
        - type
      title: OrcaResourceVendorAttributesData
    UpwindResourceVendorAttributesData:
      properties:
        vendor:
          type: string
          enum:
            - UPWIND
          const: UPWIND
          title: Vendor
          default: UPWIND
        type:
          type: string
          title: Type
      type: object
      required:
        - type
      title: UpwindResourceVendorAttributesData
    ResourceHostAgentVendorAttributes:
      properties:
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
          description: Vendor ID of the agent
        policies:
          anyOf:
            - items:
                type: object
              type: array
            - type: 'null'
          title: Policies
          description: Policies associated with the agent
      type: object
      title: ResourceHostAgentVendorAttributes
  securitySchemes:
    Connection-ID:
      type: apiKey
      in: header
      name: X-CONNECTION-ID
    API-Key:
      type: apiKey
      in: header
      name: X-API-KEY

````